Unable to load dynamic library 引起的问题深入思考

作者: dreamfly 分类: linux,php,未分类 发布时间: 2019-01-31 12:25

php7.0安装pdo之后,php -v出现错误警告:

PHP Startup: Unable to load dynamic library '/usr/lib64/php/modules/pdo_sqlite.so'

ldd查看

ldd /usr/lib64/php/modules/pdo_sqlite.so

ldd

ldd是什么,做什么用的。

1、首先ldd不是一个可执行程序,而只是一个shell脚本

2、ldd能够显示可执行模块的dependency,其原理是通过设置一系列的环境变量,如下:LD_TRACE_LOADED_OBJECTS、LD_WARN、LD_BIND_NOW、LD_LIBRARY_VERSION、LD_VERBOSE等。当LD_TRACE_LOADED_OBJECTS环境变量不为空时,任何可执行程序在运行时,它都会只显示模块的dependency,而程序并不真正执行。要不你可以在shell终端测试一下,如下:

(1) export LD_TRACE_LOADED_OBJECTS=1

(2) 再执行任何的程序,如ls等,看看程序的运行结果

3、ldd显示可执行模块的dependency的工作原理,其实质是通过ld-linux.so(elf动态库的装载器)来实现的。我们知道,ld-linux.so模块会先于executable模块程序工作,并获得控制权,因此当上述的那些环境变量被设置时,ld-linux.so选择了显示可执行模块的dependency。

4、实际上可以直接执行ld-linux.so模块,如:/lib/ld-linux.so.2 –list program(这相当于ldd program)ldd命令使用方法(摘自ldd –help)

名称 ldd – 打印共享库的依赖关系

大纲 ldd [选项]… 文件…

描述 ldd 输出在命令行上指定的每个程序或共享库需要的共享库。

选项

–version

打印ldd的版本号

-v –verbose

打印所有信息,例如包括符号的版本信息

-d –data-relocs

执行符号重部署,并报告缺少的目标对象(只对ELF格式适用)

-r –function-relocs

对目标对象和函数执行重新部署,并报告缺少的目标对象和函数(只对ELF格式适用)

–help 用法信息

ldd的标准版本与glibc2一起提供。Libc5与老版本以前提供,在一些系统中还存在。在libc5版本中长选项不支持。另一方面,glibc2版本不支持-V选项,只提供等价的–version选项。

如果命令行中给定的库名字包含'/',这个程序的libc5版本将使用它作为库名字;否则它将在标准位置搜索库。运行一个当前目录下的共享库,加前缀"./"。

ldd不能工作在a.out格式的共享库上。

ldd不能工作在一些非常老的a.out程序上,这些程序在支持ldd的编译器发行前已经创建。如果你在这种类型的程序上使用ldd,程序将尝试argc = 0的运行方式,其结果不可预知。

如果觉得我的文章对您有用,请随意打赏。您的支持将鼓励我继续创作!

发表评论

电子邮件地址不会被公开。 必填项已用*标注